<?php

namespace Drupal\currencyapi\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\currencyapi\Services\CurrencyApiClient;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\HttpFoundation\JsonResponse;

class CurrencyApiController extends ControllerBase {

  public function __construct(
    protected CurrencyApiClient $currencyClient
  ) {}

  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('currencyapi.client')
    );
  }

  public function ratesPage(): array {
    $rates = $this->currencyClient->getExchangeRates();

    return [
      '#theme' => 'currency_rates',
      '#rates' => $rates,
      '#attached' => [
        'library' => ['currencyapi/rates'],
      ],
    ];
  }

  public function ratesJson(): JsonResponse {
    $rates = $this->currencyClient->getExchangeRates();
    return new JsonResponse($rates);
  }
}
